<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'updateOrder' => '\\StructType\\UpdateOrder',
            'userAuthModel' => '\\StructType\\UserAuthModel',
            'updateOrderRequestModel' => '\\StructType\\UpdateOrderRequestModel',
            'baseRequestModel' => '\\StructType\\BaseRequestModel',
            'orderModel' => '\\StructType\\OrderModel',
            'couponModel' => '\\StructType\\CouponModel',
            'deliveryModel' => '\\StructType\\DeliveryModel',
            'gbuyOrderModel' => '\\StructType\\GbuyOrderModel',
            'historyModel' => '\\StructType\\HistoryModel',
            'normalOrderModel' => '\\StructType\\NormalOrderModel',
            'personModel' => '\\StructType\\PersonModel',
            'packageModel' => '\\StructType\\PackageModel',
            'deliveryCvsModel' => '\\StructType\\DeliveryCvsModel',
            'itemModel' => '\\StructType\\ItemModel',
            'gbuyItemModel' => '\\StructType\\GbuyItemModel',
            'gbuyBidInventoryModel' => '\\StructType\\GbuyBidInventoryModel',
            'gbuyGchoiceModel' => '\\StructType\\GbuyGchoiceModel',
            'normalItemModel' => '\\StructType\\NormalItemModel',
            'saItemModel' => '\\StructType\\SaItemModel',
            'paymentStatusModel' => '\\StructType\\PaymentStatusModel',
            'pointModel' => '\\StructType\\PointModel',
            'rBankModel' => '\\StructType\\RBankModel',
            'saOrderModel' => '\\StructType\\SaOrderModel',
            'settlementModel' => '\\StructType\\SettlementModel',
            'cardModel' => '\\StructType\\CardModel',
            'wrappingModel' => '\\StructType\\WrappingModel',
            'updateOrderResponse' => '\\StructType\\UpdateOrderResponse',
            'asyncReceiptModel' => '\\StructType\\AsyncReceiptModel',
            'baseResponseModel' => '\\StructType\\BaseResponseModel',
            'unitErrorModel' => '\\StructType\\UnitErrorModel',
            'rBankAccountTransfer' => '\\StructType\\RBankAccountTransfer',
            'rBankAccountTransferRequestModel' => '\\StructType\\RBankAccountTransferRequestModel',
            'rBankAccountTransferResponse' => '\\StructType\\RBankAccountTransferResponse',
            'cancelOrder' => '\\StructType\\CancelOrder',
            'cancelOrderRequestModel' => '\\StructType\\CancelOrderRequestModel',
            'cancelModel' => '\\StructType\\CancelModel',
            'cancelOrderResponse' => '\\StructType\\CancelOrderResponse',
            'changeRBankToUnprocessing' => '\\StructType\\ChangeRBankToUnprocessing',
            'changeRBankToUnprocessingRequestModel' => '\\StructType\\ChangeRBankToUnprocessingRequestModel',
            'changeRBankToUnprocessingResponse' => '\\StructType\\ChangeRBankToUnprocessingResponse',
            'getResult' => '\\StructType\\GetResult',
            'getResultRequestModel' => '\\StructType\\GetResultRequestModel',
            'getResultResponse' => '\\StructType\\GetResultResponse',
            'getResultResponseModel' => '\\StructType\\GetResultResponseModel',
            'asyncResultModel' => '\\StructType\\AsyncResultModel',
            'decisionPoint' => '\\StructType\\DecisionPoint',
            'decisionPointRequestModel' => '\\StructType\\DecisionPointRequestModel',
            'decisionPointResponse' => '\\StructType\\DecisionPointResponse',
            'getEnclosureList' => '\\StructType\\GetEnclosureList',
            'getEnclosureListRequestModel' => '\\StructType\\GetEnclosureListRequestModel',
            'getEnclosureListResponse' => '\\StructType\\GetEnclosureListResponse',
            'getEnclosureListResponseModel' => '\\StructType\\GetEnclosureListResponseModel',
            'enclosureGroupModel' => '\\StructType\\EnclosureGroupModel',
            'getOrder' => '\\StructType\\GetOrder',
            'getOrderRequestModel' => '\\StructType\\GetOrderRequestModel',
            'orderSearchModel' => '\\StructType\\OrderSearchModel',
            'cardSearchModel' => '\\StructType\\CardSearchModel',
            'getOrderResponse' => '\\StructType\\GetOrderResponse',
            'getOrderResponseModel' => '\\StructType\\GetOrderResponseModel',
            'doEnclosure' => '\\StructType\\DoEnclosure',
            'doEnclosureRequestModel' => '\\StructType\\DoEnclosureRequestModel',
            'nominateEnclosureModel' => '\\StructType\\NominateEnclosureModel',
            'doEnclosureResponse' => '\\StructType\\DoEnclosureResponse',
            'doUnEnclosure' => '\\StructType\\DoUnEnclosure',
            'doUnEnclosureRequestModel' => '\\StructType\\DoUnEnclosureRequestModel',
            'nominateUnEnclosureModel' => '\\StructType\\NominateUnEnclosureModel',
            'doUnEnclosureResponse' => '\\StructType\\DoUnEnclosureResponse',
            'changeStatus' => '\\StructType\\ChangeStatus',
            'changeStatusRequestModel' => '\\StructType\\ChangeStatusRequestModel',
            'orderStatusModel' => '\\StructType\\OrderStatusModel',
            'changeStatusResponse' => '\\StructType\\ChangeStatusResponse',
            'getRequestId' => '\\StructType\\GetRequestId',
            'getRequestIdResponse' => '\\StructType\\GetRequestIdResponse',
            'getRequestIdResponseModel' => '\\StructType\\GetRequestIdResponseModel',
            'changeEnclosureParent' => '\\StructType\\ChangeEnclosureParent',
            'changeEnclosureParentRequestModel' => '\\StructType\\ChangeEnclosureParentRequestModel',
            'changeEnclosureParentModel' => '\\StructType\\ChangeEnclosureParentModel',
            'changeEnclosureParentResponse' => '\\StructType\\ChangeEnclosureParentResponse',
        );
    }
}
