<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for couponModel StructType
 * @subpackage Structs
 */
class CouponModel extends AbstractStructBase
{
    /**
     * The couponCapital
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $couponCapital;
    /**
     * The couponCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $couponCode;
    /**
     * The couponName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $couponName;
    /**
     * The couponPrice
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $couponPrice;
    /**
     * The couponSummary
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $couponSummary;
    /**
     * The couponTotalPrice
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $couponTotalPrice;
    /**
     * The couponUnit
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $couponUnit;
    /**
     * The couponUsage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $couponUsage;
    /**
     * The discountType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $discountType;
    /**
     * The expiryDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $expiryDate;
    /**
     * The feeFlag
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $feeFlag;
    /**
     * The itemId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $itemId;
    /**
     * The orderNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $orderNumber;
    /**
     * Constructor method for couponModel
     * @uses CouponModel::setCouponCapital()
     * @uses CouponModel::setCouponCode()
     * @uses CouponModel::setCouponName()
     * @uses CouponModel::setCouponPrice()
     * @uses CouponModel::setCouponSummary()
     * @uses CouponModel::setCouponTotalPrice()
     * @uses CouponModel::setCouponUnit()
     * @uses CouponModel::setCouponUsage()
     * @uses CouponModel::setDiscountType()
     * @uses CouponModel::setExpiryDate()
     * @uses CouponModel::setFeeFlag()
     * @uses CouponModel::setItemId()
     * @uses CouponModel::setOrderNumber()
     * @param int $couponCapital
     * @param string $couponCode
     * @param string $couponName
     * @param int $couponPrice
     * @param string $couponSummary
     * @param int $couponTotalPrice
     * @param int $couponUnit
     * @param int $couponUsage
     * @param int $discountType
     * @param string $expiryDate
     * @param string $feeFlag
     * @param int $itemId
     * @param string $orderNumber
     */
    public function __construct($couponCapital = null, $couponCode = null, $couponName = null, $couponPrice = null, $couponSummary = null, $couponTotalPrice = null, $couponUnit = null, $couponUsage = null, $discountType = null, $expiryDate = null, $feeFlag = null, $itemId = null, $orderNumber = null)
    {
        $this
            ->setCouponCapital($couponCapital)
            ->setCouponCode($couponCode)
            ->setCouponName($couponName)
            ->setCouponPrice($couponPrice)
            ->setCouponSummary($couponSummary)
            ->setCouponTotalPrice($couponTotalPrice)
            ->setCouponUnit($couponUnit)
            ->setCouponUsage($couponUsage)
            ->setDiscountType($discountType)
            ->setExpiryDate($expiryDate)
            ->setFeeFlag($feeFlag)
            ->setItemId($itemId)
            ->setOrderNumber($orderNumber);
    }
    /**
     * Get couponCapital value
     * @return int|null
     */
    public function getCouponCapital()
    {
        return $this->couponCapital;
    }
    /**
     * Set couponCapital value
     * @param int $couponCapital
     * @return \StructType\CouponModel
     */
    public function setCouponCapital($couponCapital = null)
    {
        // validation for constraint: int
        if (!is_null($couponCapital) && !is_numeric($couponCapital)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($couponCapital)), __LINE__);
        }
        $this->couponCapital = $couponCapital;
        return $this;
    }
    /**
     * Get couponCode value
     * @return string|null
     */
    public function getCouponCode()
    {
        return $this->couponCode;
    }
    /**
     * Set couponCode value
     * @param string $couponCode
     * @return \StructType\CouponModel
     */
    public function setCouponCode($couponCode = null)
    {
        // validation for constraint: string
        if (!is_null($couponCode) && !is_string($couponCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($couponCode)), __LINE__);
        }
        $this->couponCode = $couponCode;
        return $this;
    }
    /**
     * Get couponName value
     * @return string|null
     */
    public function getCouponName()
    {
        return $this->couponName;
    }
    /**
     * Set couponName value
     * @param string $couponName
     * @return \StructType\CouponModel
     */
    public function setCouponName($couponName = null)
    {
        // validation for constraint: string
        if (!is_null($couponName) && !is_string($couponName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($couponName)), __LINE__);
        }
        $this->couponName = $couponName;
        return $this;
    }
    /**
     * Get couponPrice value
     * @return int|null
     */
    public function getCouponPrice()
    {
        return $this->couponPrice;
    }
    /**
     * Set couponPrice value
     * @param int $couponPrice
     * @return \StructType\CouponModel
     */
    public function setCouponPrice($couponPrice = null)
    {
        // validation for constraint: int
        if (!is_null($couponPrice) && !is_numeric($couponPrice)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($couponPrice)), __LINE__);
        }
        $this->couponPrice = $couponPrice;
        return $this;
    }
    /**
     * Get couponSummary value
     * @return string|null
     */
    public function getCouponSummary()
    {
        return $this->couponSummary;
    }
    /**
     * Set couponSummary value
     * @param string $couponSummary
     * @return \StructType\CouponModel
     */
    public function setCouponSummary($couponSummary = null)
    {
        // validation for constraint: string
        if (!is_null($couponSummary) && !is_string($couponSummary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($couponSummary)), __LINE__);
        }
        $this->couponSummary = $couponSummary;
        return $this;
    }
    /**
     * Get couponTotalPrice value
     * @return int|null
     */
    public function getCouponTotalPrice()
    {
        return $this->couponTotalPrice;
    }
    /**
     * Set couponTotalPrice value
     * @param int $couponTotalPrice
     * @return \StructType\CouponModel
     */
    public function setCouponTotalPrice($couponTotalPrice = null)
    {
        // validation for constraint: int
        if (!is_null($couponTotalPrice) && !is_numeric($couponTotalPrice)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($couponTotalPrice)), __LINE__);
        }
        $this->couponTotalPrice = $couponTotalPrice;
        return $this;
    }
    /**
     * Get couponUnit value
     * @return int|null
     */
    public function getCouponUnit()
    {
        return $this->couponUnit;
    }
    /**
     * Set couponUnit value
     * @param int $couponUnit
     * @return \StructType\CouponModel
     */
    public function setCouponUnit($couponUnit = null)
    {
        // validation for constraint: int
        if (!is_null($couponUnit) && !is_numeric($couponUnit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($couponUnit)), __LINE__);
        }
        $this->couponUnit = $couponUnit;
        return $this;
    }
    /**
     * Get couponUsage value
     * @return int|null
     */
    public function getCouponUsage()
    {
        return $this->couponUsage;
    }
    /**
     * Set couponUsage value
     * @param int $couponUsage
     * @return \StructType\CouponModel
     */
    public function setCouponUsage($couponUsage = null)
    {
        // validation for constraint: int
        if (!is_null($couponUsage) && !is_numeric($couponUsage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($couponUsage)), __LINE__);
        }
        $this->couponUsage = $couponUsage;
        return $this;
    }
    /**
     * Get discountType value
     * @return int|null
     */
    public function getDiscountType()
    {
        return $this->discountType;
    }
    /**
     * Set discountType value
     * @param int $discountType
     * @return \StructType\CouponModel
     */
    public function setDiscountType($discountType = null)
    {
        // validation for constraint: int
        if (!is_null($discountType) && !is_numeric($discountType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($discountType)), __LINE__);
        }
        $this->discountType = $discountType;
        return $this;
    }
    /**
     * Get expiryDate value
     * @return string|null
     */
    public function getExpiryDate()
    {
        return $this->expiryDate;
    }
    /**
     * Set expiryDate value
     * @param string $expiryDate
     * @return \StructType\CouponModel
     */
    public function setExpiryDate($expiryDate = null)
    {
        // validation for constraint: string
        if (!is_null($expiryDate) && !is_string($expiryDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($expiryDate)), __LINE__);
        }
        $this->expiryDate = $expiryDate;
        return $this;
    }
    /**
     * Get feeFlag value
     * @return string|null
     */
    public function getFeeFlag()
    {
        return $this->feeFlag;
    }
    /**
     * Set feeFlag value
     * @param string $feeFlag
     * @return \StructType\CouponModel
     */
    public function setFeeFlag($feeFlag = null)
    {
        // validation for constraint: string
        if (!is_null($feeFlag) && !is_string($feeFlag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($feeFlag)), __LINE__);
        }
        $this->feeFlag = $feeFlag;
        return $this;
    }
    /**
     * Get itemId value
     * @return int|null
     */
    public function getItemId()
    {
        return $this->itemId;
    }
    /**
     * Set itemId value
     * @param int $itemId
     * @return \StructType\CouponModel
     */
    public function setItemId($itemId = null)
    {
        // validation for constraint: int
        if (!is_null($itemId) && !is_numeric($itemId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($itemId)), __LINE__);
        }
        $this->itemId = $itemId;
        return $this;
    }
    /**
     * Get orderNumber value
     * @return string|null
     */
    public function getOrderNumber()
    {
        return $this->orderNumber;
    }
    /**
     * Set orderNumber value
     * @param string $orderNumber
     * @return \StructType\CouponModel
     */
    public function setOrderNumber($orderNumber = null)
    {
        // validation for constraint: string
        if (!is_null($orderNumber) && !is_string($orderNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orderNumber)), __LINE__);
        }
        $this->orderNumber = $orderNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CouponModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
