<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deliveryCvsModel StructType
 * @subpackage Structs
 */
class DeliveryCvsModel extends AbstractStructBase
{
    /**
     * The areaCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $areaCode;
    /**
     * The cvsBikou
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $cvsBikou;
    /**
     * The cvsCloseTime
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $cvsCloseTime;
    /**
     * The cvsCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $cvsCode;
    /**
     * The cvsOpenTime
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $cvsOpenTime;
    /**
     * The depo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $depo;
    /**
     * The storeAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $storeAddress;
    /**
     * The storeCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $storeCode;
    /**
     * The storeGenreCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $storeGenreCode;
    /**
     * The storeName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $storeName;
    /**
     * The storePrefecture
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $storePrefecture;
    /**
     * The storeZip
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $storeZip;
    /**
     * Constructor method for deliveryCvsModel
     * @uses DeliveryCvsModel::setAreaCode()
     * @uses DeliveryCvsModel::setCvsBikou()
     * @uses DeliveryCvsModel::setCvsCloseTime()
     * @uses DeliveryCvsModel::setCvsCode()
     * @uses DeliveryCvsModel::setCvsOpenTime()
     * @uses DeliveryCvsModel::setDepo()
     * @uses DeliveryCvsModel::setStoreAddress()
     * @uses DeliveryCvsModel::setStoreCode()
     * @uses DeliveryCvsModel::setStoreGenreCode()
     * @uses DeliveryCvsModel::setStoreName()
     * @uses DeliveryCvsModel::setStorePrefecture()
     * @uses DeliveryCvsModel::setStoreZip()
     * @param string $areaCode
     * @param string $cvsBikou
     * @param string $cvsCloseTime
     * @param int $cvsCode
     * @param string $cvsOpenTime
     * @param string $depo
     * @param string $storeAddress
     * @param string $storeCode
     * @param string $storeGenreCode
     * @param string $storeName
     * @param string $storePrefecture
     * @param string $storeZip
     */
    public function __construct($areaCode = null, $cvsBikou = null, $cvsCloseTime = null, $cvsCode = null, $cvsOpenTime = null, $depo = null, $storeAddress = null, $storeCode = null, $storeGenreCode = null, $storeName = null, $storePrefecture = null, $storeZip = null)
    {
        $this
            ->setAreaCode($areaCode)
            ->setCvsBikou($cvsBikou)
            ->setCvsCloseTime($cvsCloseTime)
            ->setCvsCode($cvsCode)
            ->setCvsOpenTime($cvsOpenTime)
            ->setDepo($depo)
            ->setStoreAddress($storeAddress)
            ->setStoreCode($storeCode)
            ->setStoreGenreCode($storeGenreCode)
            ->setStoreName($storeName)
            ->setStorePrefecture($storePrefecture)
            ->setStoreZip($storeZip);
    }
    /**
     * Get areaCode value
     * @return string|null
     */
    public function getAreaCode()
    {
        return $this->areaCode;
    }
    /**
     * Set areaCode value
     * @param string $areaCode
     * @return \StructType\DeliveryCvsModel
     */
    public function setAreaCode($areaCode = null)
    {
        // validation for constraint: string
        if (!is_null($areaCode) && !is_string($areaCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($areaCode)), __LINE__);
        }
        $this->areaCode = $areaCode;
        return $this;
    }
    /**
     * Get cvsBikou value
     * @return string|null
     */
    public function getCvsBikou()
    {
        return $this->cvsBikou;
    }
    /**
     * Set cvsBikou value
     * @param string $cvsBikou
     * @return \StructType\DeliveryCvsModel
     */
    public function setCvsBikou($cvsBikou = null)
    {
        // validation for constraint: string
        if (!is_null($cvsBikou) && !is_string($cvsBikou)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cvsBikou)), __LINE__);
        }
        $this->cvsBikou = $cvsBikou;
        return $this;
    }
    /**
     * Get cvsCloseTime value
     * @return string|null
     */
    public function getCvsCloseTime()
    {
        return $this->cvsCloseTime;
    }
    /**
     * Set cvsCloseTime value
     * @param string $cvsCloseTime
     * @return \StructType\DeliveryCvsModel
     */
    public function setCvsCloseTime($cvsCloseTime = null)
    {
        // validation for constraint: string
        if (!is_null($cvsCloseTime) && !is_string($cvsCloseTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cvsCloseTime)), __LINE__);
        }
        $this->cvsCloseTime = $cvsCloseTime;
        return $this;
    }
    /**
     * Get cvsCode value
     * @return int|null
     */
    public function getCvsCode()
    {
        return $this->cvsCode;
    }
    /**
     * Set cvsCode value
     * @param int $cvsCode
     * @return \StructType\DeliveryCvsModel
     */
    public function setCvsCode($cvsCode = null)
    {
        // validation for constraint: int
        if (!is_null($cvsCode) && !is_numeric($cvsCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($cvsCode)), __LINE__);
        }
        $this->cvsCode = $cvsCode;
        return $this;
    }
    /**
     * Get cvsOpenTime value
     * @return string|null
     */
    public function getCvsOpenTime()
    {
        return $this->cvsOpenTime;
    }
    /**
     * Set cvsOpenTime value
     * @param string $cvsOpenTime
     * @return \StructType\DeliveryCvsModel
     */
    public function setCvsOpenTime($cvsOpenTime = null)
    {
        // validation for constraint: string
        if (!is_null($cvsOpenTime) && !is_string($cvsOpenTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cvsOpenTime)), __LINE__);
        }
        $this->cvsOpenTime = $cvsOpenTime;
        return $this;
    }
    /**
     * Get depo value
     * @return string|null
     */
    public function getDepo()
    {
        return $this->depo;
    }
    /**
     * Set depo value
     * @param string $depo
     * @return \StructType\DeliveryCvsModel
     */
    public function setDepo($depo = null)
    {
        // validation for constraint: string
        if (!is_null($depo) && !is_string($depo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($depo)), __LINE__);
        }
        $this->depo = $depo;
        return $this;
    }
    /**
     * Get storeAddress value
     * @return string|null
     */
    public function getStoreAddress()
    {
        return $this->storeAddress;
    }
    /**
     * Set storeAddress value
     * @param string $storeAddress
     * @return \StructType\DeliveryCvsModel
     */
    public function setStoreAddress($storeAddress = null)
    {
        // validation for constraint: string
        if (!is_null($storeAddress) && !is_string($storeAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($storeAddress)), __LINE__);
        }
        $this->storeAddress = $storeAddress;
        return $this;
    }
    /**
     * Get storeCode value
     * @return string|null
     */
    public function getStoreCode()
    {
        return $this->storeCode;
    }
    /**
     * Set storeCode value
     * @param string $storeCode
     * @return \StructType\DeliveryCvsModel
     */
    public function setStoreCode($storeCode = null)
    {
        // validation for constraint: string
        if (!is_null($storeCode) && !is_string($storeCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($storeCode)), __LINE__);
        }
        $this->storeCode = $storeCode;
        return $this;
    }
    /**
     * Get storeGenreCode value
     * @return string|null
     */
    public function getStoreGenreCode()
    {
        return $this->storeGenreCode;
    }
    /**
     * Set storeGenreCode value
     * @param string $storeGenreCode
     * @return \StructType\DeliveryCvsModel
     */
    public function setStoreGenreCode($storeGenreCode = null)
    {
        // validation for constraint: string
        if (!is_null($storeGenreCode) && !is_string($storeGenreCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($storeGenreCode)), __LINE__);
        }
        $this->storeGenreCode = $storeGenreCode;
        return $this;
    }
    /**
     * Get storeName value
     * @return string|null
     */
    public function getStoreName()
    {
        return $this->storeName;
    }
    /**
     * Set storeName value
     * @param string $storeName
     * @return \StructType\DeliveryCvsModel
     */
    public function setStoreName($storeName = null)
    {
        // validation for constraint: string
        if (!is_null($storeName) && !is_string($storeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($storeName)), __LINE__);
        }
        $this->storeName = $storeName;
        return $this;
    }
    /**
     * Get storePrefecture value
     * @return string|null
     */
    public function getStorePrefecture()
    {
        return $this->storePrefecture;
    }
    /**
     * Set storePrefecture value
     * @param string $storePrefecture
     * @return \StructType\DeliveryCvsModel
     */
    public function setStorePrefecture($storePrefecture = null)
    {
        // validation for constraint: string
        if (!is_null($storePrefecture) && !is_string($storePrefecture)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($storePrefecture)), __LINE__);
        }
        $this->storePrefecture = $storePrefecture;
        return $this;
    }
    /**
     * Get storeZip value
     * @return string|null
     */
    public function getStoreZip()
    {
        return $this->storeZip;
    }
    /**
     * Set storeZip value
     * @param string $storeZip
     * @return \StructType\DeliveryCvsModel
     */
    public function setStoreZip($storeZip = null)
    {
        // validation for constraint: string
        if (!is_null($storeZip) && !is_string($storeZip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($storeZip)), __LINE__);
        }
        $this->storeZip = $storeZip;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeliveryCvsModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
