<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deliveryModel StructType
 * @subpackage Structs
 */
class DeliveryModel extends AbstractStructBase
{
    /**
     * The deliveryClass
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $deliveryClass;
    /**
     * The deliveryName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $deliveryName;
    /**
     * Constructor method for deliveryModel
     * @uses DeliveryModel::setDeliveryClass()
     * @uses DeliveryModel::setDeliveryName()
     * @param int $deliveryClass
     * @param string $deliveryName
     */
    public function __construct($deliveryClass = null, $deliveryName = null)
    {
        $this
            ->setDeliveryClass($deliveryClass)
            ->setDeliveryName($deliveryName);
    }
    /**
     * Get deliveryClass value
     * @return int|null
     */
    public function getDeliveryClass()
    {
        return $this->deliveryClass;
    }
    /**
     * Set deliveryClass value
     * @param int $deliveryClass
     * @return \StructType\DeliveryModel
     */
    public function setDeliveryClass($deliveryClass = null)
    {
        // validation for constraint: int
        if (!is_null($deliveryClass) && !is_numeric($deliveryClass)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($deliveryClass)), __LINE__);
        }
        $this->deliveryClass = $deliveryClass;
        return $this;
    }
    /**
     * Get deliveryName value
     * @return string|null
     */
    public function getDeliveryName()
    {
        return $this->deliveryName;
    }
    /**
     * Set deliveryName value
     * @param string $deliveryName
     * @return \StructType\DeliveryModel
     */
    public function setDeliveryName($deliveryName = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryName) && !is_string($deliveryName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deliveryName)), __LINE__);
        }
        $this->deliveryName = $deliveryName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeliveryModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
