<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getEnclosureListResponseModel StructType
 * @subpackage Structs
 */
class GetEnclosureListResponseModel extends BaseResponseModel
{
    /**
     * The enclosureGroupModelList
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EnclosureGroupModel[]
     */
    public $enclosureGroupModelList;
    /**
     * Constructor method for getEnclosureListResponseModel
     * @uses GetEnclosureListResponseModel::setEnclosureGroupModelList()
     * @param \StructType\EnclosureGroupModel[] $enclosureGroupModelList
     */
    public function __construct(array $enclosureGroupModelList = array())
    {
        $this
            ->setEnclosureGroupModelList($enclosureGroupModelList);
    }
    /**
     * Get enclosureGroupModelList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EnclosureGroupModel[]|null
     */
    public function getEnclosureGroupModelList()
    {
        return isset($this->enclosureGroupModelList) ? $this->enclosureGroupModelList : null;
    }
    /**
     * Set enclosureGroupModelList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EnclosureGroupModel[] $enclosureGroupModelList
     * @return \StructType\GetEnclosureListResponseModel
     */
    public function setEnclosureGroupModelList(array $enclosureGroupModelList = array())
    {
        foreach ($enclosureGroupModelList as $getEnclosureListResponseModelEnclosureGroupModelListItem) {
            // validation for constraint: itemType
            if (!$getEnclosureListResponseModelEnclosureGroupModelListItem instanceof \StructType\EnclosureGroupModel) {
                throw new \InvalidArgumentException(sprintf('The enclosureGroupModelList property can only contain items of \StructType\EnclosureGroupModel, "%s" given', is_object($getEnclosureListResponseModelEnclosureGroupModelListItem) ? get_class($getEnclosureListResponseModelEnclosureGroupModelListItem) : gettype($getEnclosureListResponseModelEnclosureGroupModelListItem)), __LINE__);
            }
        }
        if (is_null($enclosureGroupModelList) || (is_array($enclosureGroupModelList) && empty($enclosureGroupModelList))) {
            unset($this->enclosureGroupModelList);
        } else {
            $this->enclosureGroupModelList = $enclosureGroupModelList;
        }
        return $this;
    }
    /**
     * Add item to enclosureGroupModelList value
     * @throws \InvalidArgumentException
     * @param \StructType\EnclosureGroupModel $item
     * @return \StructType\GetEnclosureListResponseModel
     */
    public function addToEnclosureGroupModelList(\StructType\EnclosureGroupModel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EnclosureGroupModel) {
            throw new \InvalidArgumentException(sprintf('The enclosureGroupModelList property can only contain items of \StructType\EnclosureGroupModel, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->enclosureGroupModelList[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetEnclosureListResponseModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
