<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for normalItemModel StructType
 * @subpackage Structs
 */
class NormalItemModel extends AbstractStructBase
{
    /**
     * The delvdateInfo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $delvdateInfo;
    /**
     * The inventoryType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $inventoryType;
    /**
     * Constructor method for normalItemModel
     * @uses NormalItemModel::setDelvdateInfo()
     * @uses NormalItemModel::setInventoryType()
     * @param string $delvdateInfo
     * @param string $inventoryType
     */
    public function __construct($delvdateInfo = null, $inventoryType = null)
    {
        $this
            ->setDelvdateInfo($delvdateInfo)
            ->setInventoryType($inventoryType);
    }
    /**
     * Get delvdateInfo value
     * @return string|null
     */
    public function getDelvdateInfo()
    {
        return $this->delvdateInfo;
    }
    /**
     * Set delvdateInfo value
     * @param string $delvdateInfo
     * @return \StructType\NormalItemModel
     */
    public function setDelvdateInfo($delvdateInfo = null)
    {
        // validation for constraint: string
        if (!is_null($delvdateInfo) && !is_string($delvdateInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($delvdateInfo)), __LINE__);
        }
        $this->delvdateInfo = $delvdateInfo;
        return $this;
    }
    /**
     * Get inventoryType value
     * @return string|null
     */
    public function getInventoryType()
    {
        return $this->inventoryType;
    }
    /**
     * Set inventoryType value
     * @param string $inventoryType
     * @return \StructType\NormalItemModel
     */
    public function setInventoryType($inventoryType = null)
    {
        // validation for constraint: string
        if (!is_null($inventoryType) && !is_string($inventoryType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($inventoryType)), __LINE__);
        }
        $this->inventoryType = $inventoryType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NormalItemModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
