<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for personModel StructType
 * @subpackage Structs
 */
class PersonModel extends AbstractStructBase
{
    /**
     * The birthDay
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $birthDay;
    /**
     * The birthMonth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $birthMonth;
    /**
     * The birthYear
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $birthYear;
    /**
     * The city
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $city;
    /**
     * The emailAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $emailAddress;
    /**
     * The familyName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $familyName;
    /**
     * The familyNameKana
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $familyNameKana;
    /**
     * The firstName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $firstName;
    /**
     * The firstNameKana
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $firstNameKana;
    /**
     * The nickname
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $nickname;
    /**
     * The phoneNumber1
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $phoneNumber1;
    /**
     * The phoneNumber2
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $phoneNumber2;
    /**
     * The phoneNumber3
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $phoneNumber3;
    /**
     * The prefecture
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $prefecture;
    /**
     * The sex
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $sex;
    /**
     * The subAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $subAddress;
    /**
     * The zipCode1
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $zipCode1;
    /**
     * The zipCode2
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $zipCode2;
    /**
     * Constructor method for personModel
     * @uses PersonModel::setBirthDay()
     * @uses PersonModel::setBirthMonth()
     * @uses PersonModel::setBirthYear()
     * @uses PersonModel::setCity()
     * @uses PersonModel::setEmailAddress()
     * @uses PersonModel::setFamilyName()
     * @uses PersonModel::setFamilyNameKana()
     * @uses PersonModel::setFirstName()
     * @uses PersonModel::setFirstNameKana()
     * @uses PersonModel::setNickname()
     * @uses PersonModel::setPhoneNumber1()
     * @uses PersonModel::setPhoneNumber2()
     * @uses PersonModel::setPhoneNumber3()
     * @uses PersonModel::setPrefecture()
     * @uses PersonModel::setSex()
     * @uses PersonModel::setSubAddress()
     * @uses PersonModel::setZipCode1()
     * @uses PersonModel::setZipCode2()
     * @param string $birthDay
     * @param string $birthMonth
     * @param string $birthYear
     * @param string $city
     * @param string $emailAddress
     * @param string $familyName
     * @param string $familyNameKana
     * @param string $firstName
     * @param string $firstNameKana
     * @param string $nickname
     * @param string $phoneNumber1
     * @param string $phoneNumber2
     * @param string $phoneNumber3
     * @param string $prefecture
     * @param string $sex
     * @param string $subAddress
     * @param string $zipCode1
     * @param string $zipCode2
     */
    public function __construct($birthDay = null, $birthMonth = null, $birthYear = null, $city = null, $emailAddress = null, $familyName = null, $familyNameKana = null, $firstName = null, $firstNameKana = null, $nickname = null, $phoneNumber1 = null, $phoneNumber2 = null, $phoneNumber3 = null, $prefecture = null, $sex = null, $subAddress = null, $zipCode1 = null, $zipCode2 = null)
    {
        $this
            ->setBirthDay($birthDay)
            ->setBirthMonth($birthMonth)
            ->setBirthYear($birthYear)
            ->setCity($city)
            ->setEmailAddress($emailAddress)
            ->setFamilyName($familyName)
            ->setFamilyNameKana($familyNameKana)
            ->setFirstName($firstName)
            ->setFirstNameKana($firstNameKana)
            ->setNickname($nickname)
            ->setPhoneNumber1($phoneNumber1)
            ->setPhoneNumber2($phoneNumber2)
            ->setPhoneNumber3($phoneNumber3)
            ->setPrefecture($prefecture)
            ->setSex($sex)
            ->setSubAddress($subAddress)
            ->setZipCode1($zipCode1)
            ->setZipCode2($zipCode2);
    }
    /**
     * Get birthDay value
     * @return string|null
     */
    public function getBirthDay()
    {
        return $this->birthDay;
    }
    /**
     * Set birthDay value
     * @param string $birthDay
     * @return \StructType\PersonModel
     */
    public function setBirthDay($birthDay = null)
    {
        // validation for constraint: string
        if (!is_null($birthDay) && !is_string($birthDay)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($birthDay)), __LINE__);
        }
        $this->birthDay = $birthDay;
        return $this;
    }
    /**
     * Get birthMonth value
     * @return string|null
     */
    public function getBirthMonth()
    {
        return $this->birthMonth;
    }
    /**
     * Set birthMonth value
     * @param string $birthMonth
     * @return \StructType\PersonModel
     */
    public function setBirthMonth($birthMonth = null)
    {
        // validation for constraint: string
        if (!is_null($birthMonth) && !is_string($birthMonth)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($birthMonth)), __LINE__);
        }
        $this->birthMonth = $birthMonth;
        return $this;
    }
    /**
     * Get birthYear value
     * @return string|null
     */
    public function getBirthYear()
    {
        return $this->birthYear;
    }
    /**
     * Set birthYear value
     * @param string $birthYear
     * @return \StructType\PersonModel
     */
    public function setBirthYear($birthYear = null)
    {
        // validation for constraint: string
        if (!is_null($birthYear) && !is_string($birthYear)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($birthYear)), __LINE__);
        }
        $this->birthYear = $birthYear;
        return $this;
    }
    /**
     * Get city value
     * @return string|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return \StructType\PersonModel
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get emailAddress value
     * @return string|null
     */
    public function getEmailAddress()
    {
        return $this->emailAddress;
    }
    /**
     * Set emailAddress value
     * @param string $emailAddress
     * @return \StructType\PersonModel
     */
    public function setEmailAddress($emailAddress = null)
    {
        // validation for constraint: string
        if (!is_null($emailAddress) && !is_string($emailAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($emailAddress)), __LINE__);
        }
        $this->emailAddress = $emailAddress;
        return $this;
    }
    /**
     * Get familyName value
     * @return string|null
     */
    public function getFamilyName()
    {
        return $this->familyName;
    }
    /**
     * Set familyName value
     * @param string $familyName
     * @return \StructType\PersonModel
     */
    public function setFamilyName($familyName = null)
    {
        // validation for constraint: string
        if (!is_null($familyName) && !is_string($familyName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($familyName)), __LINE__);
        }
        $this->familyName = $familyName;
        return $this;
    }
    /**
     * Get familyNameKana value
     * @return string|null
     */
    public function getFamilyNameKana()
    {
        return $this->familyNameKana;
    }
    /**
     * Set familyNameKana value
     * @param string $familyNameKana
     * @return \StructType\PersonModel
     */
    public function setFamilyNameKana($familyNameKana = null)
    {
        // validation for constraint: string
        if (!is_null($familyNameKana) && !is_string($familyNameKana)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($familyNameKana)), __LINE__);
        }
        $this->familyNameKana = $familyNameKana;
        return $this;
    }
    /**
     * Get firstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->firstName;
    }
    /**
     * Set firstName value
     * @param string $firstName
     * @return \StructType\PersonModel
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($firstName)), __LINE__);
        }
        $this->firstName = $firstName;
        return $this;
    }
    /**
     * Get firstNameKana value
     * @return string|null
     */
    public function getFirstNameKana()
    {
        return $this->firstNameKana;
    }
    /**
     * Set firstNameKana value
     * @param string $firstNameKana
     * @return \StructType\PersonModel
     */
    public function setFirstNameKana($firstNameKana = null)
    {
        // validation for constraint: string
        if (!is_null($firstNameKana) && !is_string($firstNameKana)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($firstNameKana)), __LINE__);
        }
        $this->firstNameKana = $firstNameKana;
        return $this;
    }
    /**
     * Get nickname value
     * @return string|null
     */
    public function getNickname()
    {
        return $this->nickname;
    }
    /**
     * Set nickname value
     * @param string $nickname
     * @return \StructType\PersonModel
     */
    public function setNickname($nickname = null)
    {
        // validation for constraint: string
        if (!is_null($nickname) && !is_string($nickname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($nickname)), __LINE__);
        }
        $this->nickname = $nickname;
        return $this;
    }
    /**
     * Get phoneNumber1 value
     * @return string|null
     */
    public function getPhoneNumber1()
    {
        return $this->phoneNumber1;
    }
    /**
     * Set phoneNumber1 value
     * @param string $phoneNumber1
     * @return \StructType\PersonModel
     */
    public function setPhoneNumber1($phoneNumber1 = null)
    {
        // validation for constraint: string
        if (!is_null($phoneNumber1) && !is_string($phoneNumber1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phoneNumber1)), __LINE__);
        }
        $this->phoneNumber1 = $phoneNumber1;
        return $this;
    }
    /**
     * Get phoneNumber2 value
     * @return string|null
     */
    public function getPhoneNumber2()
    {
        return $this->phoneNumber2;
    }
    /**
     * Set phoneNumber2 value
     * @param string $phoneNumber2
     * @return \StructType\PersonModel
     */
    public function setPhoneNumber2($phoneNumber2 = null)
    {
        // validation for constraint: string
        if (!is_null($phoneNumber2) && !is_string($phoneNumber2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phoneNumber2)), __LINE__);
        }
        $this->phoneNumber2 = $phoneNumber2;
        return $this;
    }
    /**
     * Get phoneNumber3 value
     * @return string|null
     */
    public function getPhoneNumber3()
    {
        return $this->phoneNumber3;
    }
    /**
     * Set phoneNumber3 value
     * @param string $phoneNumber3
     * @return \StructType\PersonModel
     */
    public function setPhoneNumber3($phoneNumber3 = null)
    {
        // validation for constraint: string
        if (!is_null($phoneNumber3) && !is_string($phoneNumber3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phoneNumber3)), __LINE__);
        }
        $this->phoneNumber3 = $phoneNumber3;
        return $this;
    }
    /**
     * Get prefecture value
     * @return string|null
     */
    public function getPrefecture()
    {
        return $this->prefecture;
    }
    /**
     * Set prefecture value
     * @param string $prefecture
     * @return \StructType\PersonModel
     */
    public function setPrefecture($prefecture = null)
    {
        // validation for constraint: string
        if (!is_null($prefecture) && !is_string($prefecture)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prefecture)), __LINE__);
        }
        $this->prefecture = $prefecture;
        return $this;
    }
    /**
     * Get sex value
     * @return string|null
     */
    public function getSex()
    {
        return $this->sex;
    }
    /**
     * Set sex value
     * @param string $sex
     * @return \StructType\PersonModel
     */
    public function setSex($sex = null)
    {
        // validation for constraint: string
        if (!is_null($sex) && !is_string($sex)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sex)), __LINE__);
        }
        $this->sex = $sex;
        return $this;
    }
    /**
     * Get subAddress value
     * @return string|null
     */
    public function getSubAddress()
    {
        return $this->subAddress;
    }
    /**
     * Set subAddress value
     * @param string $subAddress
     * @return \StructType\PersonModel
     */
    public function setSubAddress($subAddress = null)
    {
        // validation for constraint: string
        if (!is_null($subAddress) && !is_string($subAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($subAddress)), __LINE__);
        }
        $this->subAddress = $subAddress;
        return $this;
    }
    /**
     * Get zipCode1 value
     * @return string|null
     */
    public function getZipCode1()
    {
        return $this->zipCode1;
    }
    /**
     * Set zipCode1 value
     * @param string $zipCode1
     * @return \StructType\PersonModel
     */
    public function setZipCode1($zipCode1 = null)
    {
        // validation for constraint: string
        if (!is_null($zipCode1) && !is_string($zipCode1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($zipCode1)), __LINE__);
        }
        $this->zipCode1 = $zipCode1;
        return $this;
    }
    /**
     * Get zipCode2 value
     * @return string|null
     */
    public function getZipCode2()
    {
        return $this->zipCode2;
    }
    /**
     * Set zipCode2 value
     * @param string $zipCode2
     * @return \StructType\PersonModel
     */
    public function setZipCode2($zipCode2 = null)
    {
        // validation for constraint: string
        if (!is_null($zipCode2) && !is_string($zipCode2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($zipCode2)), __LINE__);
        }
        $this->zipCode2 = $zipCode2;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PersonModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
