<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for pointModel StructType
 * @subpackage Structs
 */
class PointModel extends AbstractStructBase
{
    /**
     * The pointUsage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $pointUsage;
    /**
     * The status
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $status;
    /**
     * The usedPoint
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $usedPoint;
    /**
     * Constructor method for pointModel
     * @uses PointModel::setPointUsage()
     * @uses PointModel::setStatus()
     * @uses PointModel::setUsedPoint()
     * @param int $pointUsage
     * @param int $status
     * @param int $usedPoint
     */
    public function __construct($pointUsage = null, $status = null, $usedPoint = null)
    {
        $this
            ->setPointUsage($pointUsage)
            ->setStatus($status)
            ->setUsedPoint($usedPoint);
    }
    /**
     * Get pointUsage value
     * @return int|null
     */
    public function getPointUsage()
    {
        return $this->pointUsage;
    }
    /**
     * Set pointUsage value
     * @param int $pointUsage
     * @return \StructType\PointModel
     */
    public function setPointUsage($pointUsage = null)
    {
        // validation for constraint: int
        if (!is_null($pointUsage) && !is_numeric($pointUsage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($pointUsage)), __LINE__);
        }
        $this->pointUsage = $pointUsage;
        return $this;
    }
    /**
     * Get status value
     * @return int|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param int $status
     * @return \StructType\PointModel
     */
    public function setStatus($status = null)
    {
        // validation for constraint: int
        if (!is_null($status) && !is_numeric($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get usedPoint value
     * @return int|null
     */
    public function getUsedPoint()
    {
        return $this->usedPoint;
    }
    /**
     * Set usedPoint value
     * @param int $usedPoint
     * @return \StructType\PointModel
     */
    public function setUsedPoint($usedPoint = null)
    {
        // validation for constraint: int
        if (!is_null($usedPoint) && !is_numeric($usedPoint)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($usedPoint)), __LINE__);
        }
        $this->usedPoint = $usedPoint;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PointModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
