<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for saOrderModel StructType
 * @subpackage Structs
 */
class SaOrderModel extends AbstractStructBase
{
    /**
     * The bidId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $bidId;
    /**
     * The comment
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $comment;
    /**
     * The regDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $regDate;
    /**
     * Constructor method for saOrderModel
     * @uses SaOrderModel::setBidId()
     * @uses SaOrderModel::setComment()
     * @uses SaOrderModel::setRegDate()
     * @param int $bidId
     * @param string $comment
     * @param string $regDate
     */
    public function __construct($bidId = null, $comment = null, $regDate = null)
    {
        $this
            ->setBidId($bidId)
            ->setComment($comment)
            ->setRegDate($regDate);
    }
    /**
     * Get bidId value
     * @return int|null
     */
    public function getBidId()
    {
        return $this->bidId;
    }
    /**
     * Set bidId value
     * @param int $bidId
     * @return \StructType\SaOrderModel
     */
    public function setBidId($bidId = null)
    {
        // validation for constraint: int
        if (!is_null($bidId) && !is_numeric($bidId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($bidId)), __LINE__);
        }
        $this->bidId = $bidId;
        return $this;
    }
    /**
     * Get comment value
     * @return string|null
     */
    public function getComment()
    {
        return $this->comment;
    }
    /**
     * Set comment value
     * @param string $comment
     * @return \StructType\SaOrderModel
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($comment)), __LINE__);
        }
        $this->comment = $comment;
        return $this;
    }
    /**
     * Get regDate value
     * @return string|null
     */
    public function getRegDate()
    {
        return $this->regDate;
    }
    /**
     * Set regDate value
     * @param string $regDate
     * @return \StructType\SaOrderModel
     */
    public function setRegDate($regDate = null)
    {
        // validation for constraint: string
        if (!is_null($regDate) && !is_string($regDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($regDate)), __LINE__);
        }
        $this->regDate = $regDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SaOrderModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
