<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for settlementModel StructType
 * @subpackage Structs
 */
class SettlementModel extends AbstractStructBase
{
    /**
     * The cardModel
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CardModel
     */
    public $cardModel;
    /**
     * The settlementName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $settlementName;
    /**
     * Constructor method for settlementModel
     * @uses SettlementModel::setCardModel()
     * @uses SettlementModel::setSettlementName()
     * @param \StructType\CardModel $cardModel
     * @param string $settlementName
     */
    public function __construct(\StructType\CardModel $cardModel = null, $settlementName = null)
    {
        $this
            ->setCardModel($cardModel)
            ->setSettlementName($settlementName);
    }
    /**
     * Get cardModel value
     * @return \StructType\CardModel|null
     */
    public function getCardModel()
    {
        return $this->cardModel;
    }
    /**
     * Set cardModel value
     * @param \StructType\CardModel $cardModel
     * @return \StructType\SettlementModel
     */
    public function setCardModel(\StructType\CardModel $cardModel = null)
    {
        $this->cardModel = $cardModel;
        return $this;
    }
    /**
     * Get settlementName value
     * @return string|null
     */
    public function getSettlementName()
    {
        return $this->settlementName;
    }
    /**
     * Set settlementName value
     * @param string $settlementName
     * @return \StructType\SettlementModel
     */
    public function setSettlementName($settlementName = null)
    {
        // validation for constraint: string
        if (!is_null($settlementName) && !is_string($settlementName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($settlementName)), __LINE__);
        }
        $this->settlementName = $settlementName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SettlementModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
