<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for wrappingModel StructType
 * @subpackage Structs
 */
class WrappingModel extends AbstractStructBase
{
    /**
     * The deleteWrappingFlg
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $deleteWrappingFlg;
    /**
     * The isIncludedTax
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $isIncludedTax;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The price
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $price;
    /**
     * The title
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $title;
    /**
     * Constructor method for wrappingModel
     * @uses WrappingModel::setDeleteWrappingFlg()
     * @uses WrappingModel::setIsIncludedTax()
     * @uses WrappingModel::setName()
     * @uses WrappingModel::setPrice()
     * @uses WrappingModel::setTitle()
     * @param bool $deleteWrappingFlg
     * @param bool $isIncludedTax
     * @param string $name
     * @param int $price
     * @param string $title
     */
    public function __construct($deleteWrappingFlg = null, $isIncludedTax = null, $name = null, $price = null, $title = null)
    {
        $this
            ->setDeleteWrappingFlg($deleteWrappingFlg)
            ->setIsIncludedTax($isIncludedTax)
            ->setName($name)
            ->setPrice($price)
            ->setTitle($title);
    }
    /**
     * Get deleteWrappingFlg value
     * @return bool|null
     */
    public function getDeleteWrappingFlg()
    {
        return $this->deleteWrappingFlg;
    }
    /**
     * Set deleteWrappingFlg value
     * @param bool $deleteWrappingFlg
     * @return \StructType\WrappingModel
     */
    public function setDeleteWrappingFlg($deleteWrappingFlg = null)
    {
        $this->deleteWrappingFlg = $deleteWrappingFlg;
        return $this;
    }
    /**
     * Get isIncludedTax value
     * @return bool|null
     */
    public function getIsIncludedTax()
    {
        return $this->isIncludedTax;
    }
    /**
     * Set isIncludedTax value
     * @param bool $isIncludedTax
     * @return \StructType\WrappingModel
     */
    public function setIsIncludedTax($isIncludedTax = null)
    {
        $this->isIncludedTax = $isIncludedTax;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\WrappingModel
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get price value
     * @return int|null
     */
    public function getPrice()
    {
        return $this->price;
    }
    /**
     * Set price value
     * @param int $price
     * @return \StructType\WrappingModel
     */
    public function setPrice($price = null)
    {
        // validation for constraint: int
        if (!is_null($price) && !is_numeric($price)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($price)), __LINE__);
        }
        $this->price = $price;
        return $this;
    }
    /**
     * Get title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param string $title
     * @return \StructType\WrappingModel
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($title)), __LINE__);
        }
        $this->title = $title;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WrappingModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
